function [patches, patchIdx] = extract_patches(PATCH_SIZE, X)

  N_INSTANCE = size(X,1);
  N_SAMPLE = size(X,2);
  assert (N_SAMPLE > PATCH_SIZE)

  N_INSTANCE_PER = N_SAMPLE - PATCH_SIZE + 1;
  patches = zeros(N_INSTANCE_PER*N_INSTANCE, PATCH_SIZE);
  patchIdx = zeros(N_INSTANCE_PER*N_INSTANCE, 1);

  for i = [1:N_INSTANCE]
    mypatch = im2col(X(i,:),[1 PATCH_SIZE]);
    rr = [(i-1)*N_INSTANCE_PER + 1:i*N_INSTANCE_PER];
    patches(rr,:) = mypatch';
    patchIdx(rr,:) = ones(length(rr),1) * i;
  end